require("love_api")

function main()
  variables = "\\b(love)\\b|\\b(?&lt;=love\\.)("
  funcs = "\\b((?&lt;=\\.|:)"
  doTypes = true
  
  -- -s for shorten (by excluding type functions)
  if arg[1] == "-s" then
    doTypes = false
    file = arg[2]
  else
    file = arg[1]
  end
  
  -- love.* callbacks
  for i, cb in ipairs(love.callbacks) do
    af(cb.name .. "|")
  end
  
  -- each module
  for i, mod in ipairs(love.modules) do
    -- name
    av(mod.name)
    if i < #love.modules then av("|") end
    
    -- type functions
    if doTypes and mod.types then
      for j, cls in ipairs(mod.types) do
        if cls.functions then
          for k, func in ipairs(cls.functions) do
            af(func.name .. "|")
          end
        end
      end
    end
    
    -- functions
    for j, func in ipairs(mod.functions) do
      af(func.name)
      if not (i == #love.modules and j == #mod.functions) then af("|") end
    end
  end
  
  av("))\\b")
  af(")\\b")
  output = variables .. "\n\n" .. funcs
  
  if file then
    local f = io.open(file, "w")
    
    if not f then
      print("Error opening file")
      os.exit(1)
    end
    
    f:write(output)
    f:close()
  else
    print(output)
  end
end

-- append to variables
function av(str)
  variables = variables .. str
  return variables
end

-- append to funcs
function af(str)
  funcs = funcs .. str
  return funcs
end

main()
